//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CpkKeyWins1.h"
#include "CpkKeyClrDlgs.h"
#include "CpkKeyDelDlgs.h"
#include "pgpbuffers.h"
#include "pgpfiles.h"
#include "HelpDlgs.h"
#include "wipedlgs.h"
#include "msgwins.h"
#include "FileWin.h"
#include "ClipReply.h"
#include "global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TCpkKeyWin1 *CpkKeyWin1;
const AnsiString RRINGTXT = MixDir()+"pubring1.asc";//PgpRemailRing()
//---------------------------------------------------------------------------
// TCpkkeylist
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1()
   : TPGPkeylist()
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1(AnsiString filename)
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
   LoadFromFile(filename);
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1(TPGPbuffer *keys)
   : TPGPkeylist()
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1(TPGPkeylist *keys)
   : TPGPkeylist()
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::~TCpkKeyList1()
{
   delete shorts;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList1::LoadFromFile(AnsiString filename)
{
   TPGPbuffer *cpkkeys = new TPGPbuffer(filename);
   AddKeys(cpkkeys);
   delete cpkkeys;
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList1::AddKeys(TPGPbuffer *keys)
{
   if (!keys) return 0;
   int c=0;
   keys->rewind();
   TPGPbuffer *KEY,*key = new TPGPbuffer();
   while (key->copykeyfrom(keys,REWIND))
   {
      KEY = new TPGPbuffer();
      KEY->copykeyfrom(key,REWIND);
      AnsiString addr=GetEAddress(KEY->firstuid),shrt=shorts->Values[addr];
      if (shrt.IsEmpty()) shrt = "nameless";
      AddObject(shrt+","+addr+","+"0x"+KEY->idtext8+","+KEY->algostr,KEY);
      key->clear();
      c++;
   }
   delete key;
   return c;
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList1::AddKeys(TPGPkeylist *keys)
{
   TPGPbuffer *KEY;
   if (!keys) return 0;
   for (int i=0; i<keys->Count; i++)
   {
      KEY = new TPGPbuffer((TPGPbuffer*)keys->Objects[i]);
      KEY->parsekeycert();
      AnsiString userid=GetEAddress(KEY->firstuid),shrt=shorts->Values[userid];
      if (shrt.IsEmpty()) shrt = "nameless";
      AddObject(shrt+","+userid+","+"0x"+KEY->idtext8+","+KEY->algostr,KEY);
   }
   return keys->Count;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList1::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   TStringList *exports = new TStringList();
   TPGPbuffer *cpkkeys = new TPGPbuffer();

   for (int i=0; i<Count; i++)
      cpkkeys->copyfrom(PgpKey(i));
   cpkkeys->exporttrust(exports);

   for (int i=bakcopies; i>=1; i--)
   {
      if (FileExists(bak(docname,i))) DeleteFile(bak(docname,i).c_str());
      if (FileExists(bak(docname,i-1)))
          rename(bak(docname,i-1).c_str(),bak(docname,i).c_str());
   }
   if (bakcopies && FileExists(docname))
      rename(docname.c_str(),bak(docname,1).c_str());
   exports->SaveToFile(docname);

   delete cpkkeys;
   delete exports;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList1::GetShortAndAddressLengths(int &shrtlen, int &addrlen)
{
   shrtlen = addrlen = 0;
   for (int i=0; i<Count; i++)
   {
      AnsiString shrt=GetToken(0,Strings[i],","),addr=GetToken(1,Strings[i],",");
      if (shrt.Length()>shrtlen) shrtlen = shrt.Length();
      if (addr.Length()>addrlen) addrlen = addr.Length();
   }
}
//---------------------------------------------------------------------------
// TCpkKeyWin
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin1::TCpkKeyWin1(TComponent* Owner)
	: TForm(Owner)
{
   keys = new TCpkKeyList1();
   newkeys = new TStringList();
   keynodes = new TList();
   checksave = true;
   curkey = -1;
   SetHelpBtnPos();
   LoadKeys();
   SetNothingSelected(); SaveBtn->Enabled = RefreshBtn->Enabled = false;
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   GenTreeView();
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin1::~TCpkKeyWin1()
{
   CpkKeyWin1 = NULL;
   delete keynodes;
   delete newkeys;
   delete keys;
}
//---------------------------------------------------------------------------
TPGPbuffer* __fastcall TCpkKeyWin1::GetKey(int atPos)
{
   TPGPbuffer *key = keys->PgpKey(atPos);
   if (key) key->parsekeycert();
   return key;
}
//---------------------------------------------------------------------------
AnsiString __fastcall padrightcpk(AnsiString string, int width)
{
   AnsiString str;
   return string+str.StringOfChar(32,width-string.Length());
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SetHelpBtnPos()
{
   HelpBtn->Left = Width-58;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SetTreeItemBold(TTreeNode *ANode, bool Value,
   TTreeView *ATree)
{
   TTVItem item;
   int Template;
   if (!ANode) return;

   Template = Value ? -1 : 0;
   item.mask = TVIF_STATE;
   item.hItem = (HTREEITEM)ANode->ItemId;
   item.stateMask = TVIS_BOLD;
   item.state = item.stateMask & Template;
   TreeView_SetItem(ATree->Handle,&(TV_ITEM)item);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::MakeMessage(TStrings *message, AnsiString &addrs,
   AnsiString &subject)
{
   TStringList *msg = new TStringList(); msg->Text = message->Text;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString tmpstr = msg->Strings[i];
      if (tmpstr.Pos("To:")==1) msg->Strings[i] = "To: "+addrs;
      if (tmpstr.Pos("Subject:")==1) msg->Strings[i] = "Subject: "+subject;
      if (tmpstr.IsEmpty()) break;
   }
   PutMessageOnDesktop(AppMainForm,msg);
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::RemailerConfigItemClick(TObject *Sender)
{
   TMenuItem *item=dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      AnsiString remaddrs,subject,TempName;
      if (TreeView->Selected) remaddrs = TreeView->Selected->Text;
      remaddrs = GetParam(1,remaddrs," "); if (remaddrs.IsEmpty()) return;
      TStringList *temps = new TStringList();
      GetAppData(temps,UserTemplates);
      if (temps->IndexOf("config-request")>=0) TempName = "config-request";
      if (TempName.IsEmpty()) TempName =
          GetTemplateName("Select Template For Remailer Config-Request",modeMessage);
      if(!TempName.IsEmpty())
      {
         AnsiString cap = Caption; Caption = "Queueing message(s)...";
         TStringList *Template = new TStringList();
         GetAppData(Template,UserTemplates+PS+TempName);
         switch (item->Tag)
         {
            case 2:
               MakeMessage(Template,remaddrs,"remailer-config");
               break;
            case 3:
               MakeMessage(Template,remaddrs,"remailer-key"   );
               break;
            case 4:
               MakeMessage(Template,remaddrs,"remailer-help"  );
               break;
            case 5:
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
            default:
               MakeMessage(Template,remaddrs,"remailer-config");
               MakeMessage(Template,remaddrs,"remailer-key"   );
               MakeMessage(Template,remaddrs,"remailer-help"  );
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
         }
         AppMainForm->Perform(WM_QUEUECHANGE,0,NULL);
         AppMainForm->Perform(WM_SHOWSTATUS,0,
            (LPARAM)"Config-request(s) created and queued");
         delete Template;
         Sleep(200);
         Caption = cap;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::GenTreeView()
{
   TPGPbuffer *cpkkey;
   TTreeNode *node,*cnode,*unode;
   keynodes->Clear();
   TreeView->Items->Clear();
   TStringList *next = new TStringList();
   TStringList *flds = new TStringList();
   TreeView->Items->BeginUpdate();
   for (int i=0; i<keys->Count; i++)
   {
      flds->CommaText = keys->Strings[i];
      AnsiString addr,shrt,id,idtext8,user,name,tstamp,keydesc,cpkdesc,algostr;
      if ((cpkkey=GetKey(i))!=NULL)
      {
         shrt = flds->Strings[0];
         addr = flds->Strings[1];
         idtext8 = flds->Strings[2];
         node = TreeView->Items->AddChildObject(TreeView->Selected,
            padrightcpk(shrt,sLen+3)+
            padrightcpk(addr,aLen+3)+
            idtext8+"   "+flds->Strings[3]+
            (cpkkey->revoked?"  <---REVOKED ":"")+
            (cpkkey->expired?"  <---EXPIRED ":""),
            NULL
         );
         keynodes->Add(node);

         node->ImageIndex = cpkkey->enabled ? 0:1;
         node->SelectedIndex = node->ImageIndex;
         if (newkeys->IndexOf(node->Text)>=0) SetTreeItemBold(node,true,TreeView);

         cnode=TreeView->Items->AddChild(node,"Name        "+shrt);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Address     "+addr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         AnsiString keyidline = "0x"+idtext8+(cpkkey->revoked?"   <---REVOKED ":"");

         cnode=TreeView->Items->AddChild(node,"Key-Id      "+keyidline);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Key-Version "+s(cpkkey->version));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Algorithm   "+cpkkey->algostr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         cnode=TreeView->Items->AddChild(node,"UserIds     "+cpkkey->firstuid);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         TStringList *uids = new TStringList();
         cpkkey->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
         {
            unode=TreeView->Items->AddChild(cnode,uids->Strings[i]);
            unode->ImageIndex = -1; unode->SelectedIndex = -1;
         }
         delete uids;

         cnode=TreeView->Items->AddChild(node,"TimeStamp   "+cpkkey->timestr+
            (cpkkey->revoked?"  <---REVOKED ":"")+
            (cpkkey->expired?"  <---EXPIRED ":"")
         );

         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Validity    "+s(cpkkey->validity));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Bits        "+cpkkey->bitsstr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

      }
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   delete flds;
   delete next;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::FormResize(TObject *Sender)
{
   SetHelpBtnPos();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::ClearAllBtnClick(TObject *Sender)
{
   bool clrall;
   if (CpkClearKeyring(AppMainForm,clrall))
   {
      Sleep(200); int i=0; while (i<keys->Count)
      {
         if (clrall || GetKey(i)->enabled)
         {
            delete keys->Objects[i];
            keys->Delete(i);
            modified = true;
         }
         else i++;
      }
      GenTreeView();
      RefreshBtn->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::TreeViewMouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
   THitTests HitTest = TreeView->GetHitTestInfoAt(X, Y);
   if (HitTest.Contains(htOnIcon))
      DisableBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::DisableBtnClick(TObject *Sender)
{
   if (!TreeView->Selected || curkey<0 || curkey>=keys->Count) return;

   RECT r = { 0,0,50,2000 };
   TPGPbuffer *key = GetKey(curkey); key->rewind();
   bool enable=!key->enabled; key->cpkenable(enable);
   TTreeNode* node = (TTreeNode*)keynodes->Items[curkey];
   if (enable)
   {
      node->ImageIndex = 0; node->SelectedIndex = 0;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 1; node->SelectedIndex = 1;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   InvalidateRect(TreeView->Handle,&r,false);

   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
   int node0 = Node->Level==0;
   RequestBtn->Enabled = node0;
   DisableBtn->Enabled = node0;
   DeleteBtn->Enabled = node0;
   curkey = Node->Index;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::OkBtnClick(TObject *Sender)
{
   checksave = false;
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SaveKeys()
{
   if (!keys->Count)
   {
      if (FileExists(RRINGTXT)) zapfile(RRINGTXT,1);
      return;
   }
   AnsiString cap = Caption;
   Caption = "Saving..."; AppProcessMessages(); Sleep(300);
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   keys->SaveToFileBak(RRINGTXT,STATSBAKCOPIES);
   modified = false;
   newkeys->Clear();
   Caption = cap;
   Sleep(200);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (modified)
   {
      if (checksave)
      {
         switch (MsgBox("Your keyring is modified.\n\nSave your changes?",
            "Confirm",MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: break;
            default:
               SaveKeys();
         }
      }
      else SaveKeys();
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::PopCollapseItemClick(TObject *Sender)
{
   TreeView->FullCollapse();
   if (keynodes->Count) TreeView->TopItem = (TTreeNode*)keynodes->Items[0];
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::PopExpandItemClick(TObject *Sender)
{
   TreeView->FullExpand();
   if (keynodes->Count) TreeView->TopItem = (TTreeNode*)keynodes->Items[0];
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SaveBtnClick(TObject *Sender)
{
   SaveKeys();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SetNothingSelected()
{
   RequestBtn->Enabled = false;
   DisableBtn->Enabled = false;
   DeleteBtn->Enabled = false;
   curkey = -1;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SetCount(bool clear)
{
   AnsiString cur,count;
   if (Application->Terminated) return;
   if (WindowState!=wsMinimized && !clear && keys->Count)
   {
      cur = curkey>=0 ? s(curkey+1)+"/" : s("");
      count = cur+s(keys->Count);
   }
   AppMainForm->Perform(WM_SHOWSTATUS,1,(LPARAM)count.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::LoadKeys()
{
   keys->Clear();
   keys->LoadFromFile(RRINGTXT);
   keys->GetShortAndAddressLengths(sLen,aLen);
   modified = false;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::RefreshBtnClick(TObject *Sender)
{
   if (modified && MsgBox(
      s("Your keyring is modified. Refresh from disk will discard your changes?\n\n")+
      s("Refresh now?"),
      s("Confirm"),
      MB_OKCANCEL)==IDCANCEL) return;

   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   AnsiString cap = Caption;
   Caption = "Loading...";
   newkeys->Clear();
   keynodes->Clear();
   LoadKeys();
   SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
   AppProcessMessages(); SetRedraw(this,0); Sleep(300);
   GenTreeView();
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SetNothingSelected();
   SetRedraw(this,1);
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::DeleteBtnClick(TObject *Sender)
{
   if (curkey<0 && curkey>=keys->Count) return;
   if (CpkDeleteKey(AppMainForm))
   {
      delete keys->Objects[curkey];
      keys->Delete(curkey);
      bool locked = LockWindowUpdate(Handle); // works much better than setredraw here
      GenTreeView();
      AppProcessMessages(); Sleep(100);
      if (locked) LockWindowUpdate(0);
      SetNothingSelected();
      RefreshBtn->Enabled = true;
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "CypherpunkKeys\nCypherpunkKeysImp\nCypherpunkKeysDup",
      "Cypherpunk Key Manager",
      "Cypherpunk Keyring Manager"
   );
}
//---------------------------------------------------------------------------
